#
# local-fishing.R, 13 Apr 25
#
# Data from:
# The New C Standard
# Derek M. Jones

library("colorspace")
# library("plyr")


par(bty="l")
par(las=1)
par(pch="+") 
pal_col=rainbow(2)


nl=read.csv("local-LOC.csv")

plot(nl$stmt, nl$locals, log="xy", col=pal_col[2],
	xlim=c(1, 1000),
	xlab="Stmts", ylab="Locals")

# ll_mod=glm(log(locals) ~ log(stmts), data=nl, subset=(locals > 0) & (stmts > 10) & (stmts < 1000))
ll_mod=glm(locals ~ sqrt(stmts), data=nl, subset=(locals > 0) & (stmts > 1) & (stmts < 1000))

# nrow(subset(nl, (locals > 0) & (stmts > 1) & (stmts < 1000)))
# # 36617

x_bounds=1:1000
pred=predict(ll_mod, newdata=data.frame(stmts=x_bounds))

# lines(x_bounds, exp(pred), col=pal_col[1])
lines(x_bounds, pred, col=pal_col[1])

dev.copy(dev=png, file="func-stmt_local.png")
dev.off()

ll_mod=glm(log(locals) ~ log(stmts)+log(parameters), data=nl, subset=(locals > 0) & (stmts > 0) & (parameters > 0))
summary(ll_mod)

sl_mod=glm(locals ~ sqrt(stmts)+sqrt(parameters), data=nl)
summary(sl_mod)

sp_mod=glm(locals ~ sqrt(stmts)+parameters, data=nl)

