# local-use.awk, 12 Apr 25

function zero_counters()
{
num_use=0
in_metrics=0
}

BEGIN {
	zero_counters()
	seen_func=0
	print "use,func,storage,obj,offset,lines,stmts"
	}

$1 == ".INIT" {
	num_use+=1
	use_info[num_use]="init," func_name ",NONE," $2 "," $3-func_start_line+1
	next
	}

$1 == ".ACC" {
	num_use+=1
	use_info[num_use]="acc," func_name "," $2 "," $3 "," $4-func_start_line+1
	next
	}

$1 == ".MOD" {
	num_use+=1
	use_info[num_use]="mod," func_name "," $2 "," $3 "," $4-func_start_line+1
	next
	}

$1 == ".METRICS" {
	in_metrics=1
	next
	}

$1 == ".FUNC" {
	seen_func=1
	zero_counters()
	func_start_line=$3
	func_name=$2
	next
	}

$1 == ".END" {
	if (seen_func == 1)
	   {
	   for (u=1; u<=num_use; u++)
	      printf("%s,%d,%d\n", use_info[u], $2-func_start_line+1,num_stmt)
	   }
	in_metrics=0
	seen_func=0
	next
	}

$1 ~ /^\./ {
	in_metrics=0
	next
	}

	{
	if (in_metrics == 1)
	   {
	   for (i=1; i <= NF; i+=2)
	      if ($i == "STMTS")
		 {
	         has_stmt=1
		 num_stmt=$(i+1)
		 stmts_per_func[$(i+1)]++
	         }
	   }
	next
	}

END {
	}

